from dataclasses import dataclass

import httpx

# 单例
class Singleton(type):
    _instances = {}
    def __call__(cls, *args, **kwargs):
        if cls not in cls._instances:
            cls._instances[cls] = super(Singleton, cls).__call__(*args, **kwargs)
        return cls._instances[cls]

@dataclass
class Config(metaclass=Singleton):    
    client: httpx.AsyncClient = None # type: ignore

config = Config()